using Domain.Entities.Forum.Boards;
using Domain.Entities.Members;
using Domain.Entities.Forum.ValueObject;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Domain.Entities.Forum.Posts
{
    [Table("PostReaction")]
    [Index(nameof(BoardID))]
    [Index(nameof(PostID))]
    [Index(nameof(MemberID))]
    [Index(nameof(Reaction))]
    [Index(nameof(PostID), nameof(MemberID), IsUnique = true)]
    public class PostReaction
    {
        [ForeignKey(nameof(BoardID))]
        public Board Board { get; set; } = null!;

        [ForeignKey(nameof(PostID))]
        public Post Post { get; set; } = null!;

        [ForeignKey(nameof(MemberID))]
        public Member Member { get; set; } = null!;

        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [DisplayName("PK")]
        [Comment("PK")]
        public int ID { get; set; }

        [DisplayName("게시판 ID")]
        [Comment("게시판 ID")]
        public int BoardID { get; set; }

        [DisplayName("게시글 ID")]
        [Comment("게시글 ID")]
        public int PostID { get; set; }

        [DisplayName("회원 ID")]
        [Comment("회원 ID")]
        public int MemberID { get; set; }

        [DisplayName("반응 구분")]
        [Comment("반응 구분")]
        [EnumDataType(typeof(Reaction), ErrorMessage = "{0}는 {1} 중 하나를 선택하세요.")]
        public Reaction Reaction { get; set; }

        [DisplayName("IP Address")]
        [Comment("IP Address")]
        [MaxLength(50)]
        public string? IpAddress { get; set; } = null;

        [DisplayName("User-agent")]
        [Comment("User-agent")]
        [MaxLength(255)]
        public string? UserAgent { get; set; } = null;

        [DisplayName("수정 일시")]
        [Comment("수정 일시")]
        [DataType(DataType.DateTime)]
        public DateTime? UpdatedAt { get; set; } = null;

        [DisplayName("등록 일시")]
        [Comment("등록 일시")]
        [DataType(DataType.DateTime)]
        public DateTime CreatedAt { get; set; } = DateTime.UtcNow;
    }
}